# novaclient.v2.servers module

Server interface.

class novaclient.v2.servers.NetworkInterface(manager, info, loaded=False, resp=None)

  Bases: `Resource`

  Populate and bind to a manager.

  Parameters:

    - manager – BaseManager object

    - info – dictionary representing resource attributes

    - loaded – prevent lazy-loading if set to True

    - resp – Response or list of Response objects

  property id

class novaclient.v2.servers.SecurityGroup(manager, info, loaded=False, resp=None)

  Bases: `Resource`

  Populate and bind to a manager.

  Parameters:

    - manager – BaseManager object

    - info – dictionary representing resource attributes

    - loaded – prevent lazy-loading if set to True

    - resp – Response or list of Response objects

class novaclient.v2.servers.Server(manager, info, loaded=False, resp=None)

  Bases: `Resource`

  Populate and bind to a manager.

  Parameters:

    - manager – BaseManager object

    - info – dictionary representing resource attributes

    - loaded – prevent lazy-loading if set to True

    - resp – Response or list of Response objects

  HUMAN_ID = True
  add_security_group(security_group)

    Add a security group to an instance.

    Parameters:

      security_group – The name of security group to add

    Returns:

      An instance of novaclient.base.DictWithMeta

  add_tag(tag)

    Add single tag to an instance.

  backup(backup_name, backup_type, rotation)

    Backup a server instance.

    Parameters:

      - backup_name – Name of the backup image

      - backup_type – The backup type, like ‘daily’ or ‘weekly’

      - rotation – Int parameter representing how many backups to keep around.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  change_password(password)

    Update the admin password for a server.

    Parameters:

      password – string to set as the admin password on the server

    Returns:

      An instance of novaclient.base.TupleWithMeta

  clear_password()

    Get password for a Server.

  confirm_resize()

    Confirm that the resize worked, thus removing the original server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  create_image(image_name, metadata=None)

    Create an image based on this server.

    Parameters:

      - image_name – The name to assign the newly create image.

      - metadata – Metadata to assign to the image.

  delete()

    Delete (i.e. shut down and delete the image) this server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  delete_all_tags()

    Remove all tags from an instance.

  delete_tag(tag)

    Remove single tag from an instance.

  diagnostics()

    Diagnostics – Retrieve server diagnostics.

  evacuate(host=None, password=None)

    Evacuate an instance from failed host to specified host.

    Parameters:

      - host – Name of the target host

      - password – string to set as admin password on the evacuated server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  force_delete()

    Force delete – Force delete a server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  get_console_output(length=None)

    Get text console log output from Server.

    Parameters:

      length – The number of lines you would like to retrieve (as int)

  get_console_url(console_type)

    Retrieve a console of a particular protocol and console_type

    Parameters:

      console_type – Type of console

  get_mks_console()

    Get mks console for a Server.

  get_password(private_key=None)

    Get password for a Server.

    Returns the clear password of an instance if private_key is provided, returns the ciphered password otherwise.

    Parameters:

      private_key – Path to private key file for decryption (optional)

  get_rdp_console(console_type)

    Get rdp console for a Server.

    Parameters:

      console_type – Type of console (‘rdp-html5’)

  get_serial_console(console_type)

    Get serial console for a Server.

    Parameters:

      console_type – Type of console (‘serial’)

  get_spice_console(console_type)

    Get spice console for a Server.

    Parameters:

      console_type – Type of console (‘spice-html5’)

  get_vnc_console(console_type)

    Get vnc console for a Server.

    Parameters:

      console_type – Type of console (‘novnc’ or ‘xvpvnc’)

  interface_attach(port_id, net_id, fixed_ip, tag=None)

    Attach a network interface to an instance with an optional tag.

  interface_detach(port_id)

    Detach a network interface from an instance.

  interface_list()

    List interfaces attached to an instance.

  list_security_group()

    List security group(s) of an instance.

  live_migrate(host=None, block_migration=None)

    Migrates a running instance to a new machine.

    Parameters:

      - host – destination host name.

      - block_migration – if True, do block_migration, the default value is None which is mapped to ‘auto’.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  lock(reason=None)

    Lock – Lock the instance from certain operations.

    Parameters:

      reason – (Optional) The lock reason.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  migrate(host=None)

    Migrate a server to a new host.

    Parameters:

      host – (Optional) The target host.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  property networks

    Generate a simplified list of addresses

    Returns:

      An OrderedDict, keyed by network name, and sorted by network name in ascending order.

  pause()

    Pause – Pause the running server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reboot(reboot_type='SOFT')

    Reboot the server.

    Parameters:

      reboot_type – either `REBOOT_SOFT` for a software-level reboot, or REBOOT_HARD for a virtual power cycle hard reboot.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  rebuild(image, password=None, preserve_ephemeral=False, *, disk_config=None, name=None, meta=None, files=None, description=<object object>, key_name=<object object>, userdata=<object object>, trusted_image_certificates=<object object>, hostname=<object object>)

    Rebuild – shut down and then re-image – this server.

    Parameters:

      - image – The `Image` (or its ID) to re-image with.

      - password – String to set as password on the rebuilt server.

      - preserve_ephemeral – If True, request that any ephemeral device be preserved when rebuilding the instance. Defaults to False.

      - disk_config – Partitioning mode to use on the rebuilt server. Valid values are ‘AUTO’ or ‘MANUAL’

      - name – Something to name the server.

      - meta – A dict of arbitrary key/value metadata to store for this server. Both keys and values must be <=255 characters.

      - files – A dict of files to overwrite on the server upon boot. Keys are file names (i.e. `/etc/passwd`) and values are the file contents (either as a string or as a file-like object). A maximum of five entries is allowed, and each file must be 10k or less. (deprecated starting with microversion 2.57)

      - description – Optional description of the server. If None is specified, the existing description will be unset. (starting from microversion 2.19)

      - key_name – Optional key pair name for rebuild operation. If None is specified, the existing key will be unset. (starting from microversion 2.54)

      - userdata – Optional user data to pass to be exposed by the metadata server; this can be a file type object as well or a string. If None is specified, the existing user_data is unset. (starting from microversion 2.57)

      - trusted_image_certificates – A list of trusted certificate IDs or None to unset/reset the servers trusted image certificates (starting from microversion 2.63)

      - hostname – Optional hostname to configure for the instance. If None is specified, the existing hostname will be unset. (starting from microversion 2.90)

    Returns:

      `Server`

  remove_security_group(security_group)

    Remove a security group from an instance.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  rescue(password=None, image=None)

    Rescue – Rescue the problematic server.

    Parameters:

      - password – The admin password to be set in the rescue instance.

      - image – The `Image` to rescue with.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reset_network()

    Reset network of an instance.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reset_state(state='error')

    Reset the state of an instance to active or error.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  resize(flavor, *, disk_config=None)

    Resize the server’s resources.

    Parameters:

      - flavor – The `Flavor` (or its ID) to resize to.

      - disk_config – Partitioning mode to use on the rebuilt server. Valid values are ‘AUTO’ or ‘MANUAL’.

    Returns:

      An instance of novaclient.base.TupleWithMeta

    Until a resize event is confirmed with `confirm_resize()`, the old server will be kept around and you’ll be able to roll back to the old flavor quickly with `revert_resize()`. All resizes are automatically confirmed after 24 hours by default.

  restore()

    Restore – Restore a server in ‘soft-deleted’ state.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  resume()

    Resume – Resume the suspended server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  revert_resize()

    Revert a previous resize, switching back to the old server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  set_tags(tags)

    Set list of tags to an instance.

  shelve()

    Shelve – Shelve the server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  shelve_offload()

    Shelve_offload – Remove a shelved server from the compute node.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  start()

    Start – Start the paused server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  stop()

    Stop – Stop the running server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  suspend()

    Suspend – Suspend the running server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  tag_list()

    Get list of tags from an instance.

  topology()

    Retrieve server topology.

  trigger_crash_dump()

    Trigger crash dump in an instance

  unlock()

    Unlock – Remove instance lock.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unpause()

    Unpause – Unpause the paused server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unrescue()

    Unrescue – Unrescue the rescued server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unshelve(availability_zone=<object object>, host=None)

    Unshelve – Unshelve the server.

    Parameters:

      - availability_zone – If specified the instance will be unshelved to the availability_zone. If None is passed the instance defined availability_zone is unpin and the instance will be scheduled to any availability_zone (free scheduling). If not specified the instance will be unshelved to either its defined availability_zone or any availability_zone (free scheduling).

      - host – The specified host (Optional)

    Returns:

      An instance of novaclient.base.TupleWithMeta

  update(name=None, description=None, hostname=None)

    Update attributes of this server.

    Parameters:

      - name – Update the server’s name.

      - description – Update the server’s description.

      - hostname – Update the server’s hostname.

    Returns:

      `Server`

class novaclient.v2.servers.ServerManager(api)

  Bases: `BootingManagerWithFind`

  add_security_group(server, security_group)

    Add a Security Group to an instance

    Parameters:

      - server – ID of the instance.

      - security_group – The name of security group to add.

    Returns:

      An instance of novaclient.base.DictWithMeta

  add_tag(server, tag)

    Add single tag to an instance.

  backup(server, backup_name, backup_type, rotation)

    Backup a server instance.

    Parameters:

      - server – The `Server` (or its ID) to share onto.

      - backup_name – Name of the backup image

      - backup_type – The backup type, like ‘daily’ or ‘weekly’

      - rotation – Int parameter representing how many backups to keep around.

    Returns:

      An instance of novaclient.base.TupleWithMeta if the request microversion is < 2.45, otherwise novaclient.base.DictWithMeta.

  change_password(server, password)

    Update the password for a server.

    Parameters:

      server – The `Server` (or its ID) for which the admin password is to be changed

    Returns:

      An instance of novaclient.base.TupleWithMeta

  clear_password(server)

    Clear the admin password of an instance

    Remove the admin password for an instance from the metadata server.

    Parameters:

      server – The `Server` (or its ID) for which the admin password is to be cleared

  confirm_resize(server)

    Confirm that the resize worked, thus removing the original server.

    Parameters:

      server – The `Server` (or its ID) to share onto.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  create(name, image, flavor, meta=None, files=None, reservation_id=False, min_count=None, max_count=None, security_groups=None, userdata=None, key_name=None, availability_zone=None, block_device_mapping=None, block_device_mapping_v2=None, nics=None, scheduler_hints=None, config_drive=None, disk_config=None, admin_pass=None, access_ip_v4=None, access_ip_v6=None, description=None, tags=None, trusted_image_certificates=None, host=None, hypervisor_hostname=None, hostname=None)

    Create (boot) a new server.

    In order to create a server with pre-existing ports that contain a `resource_request` value, such as for guaranteed minimum bandwidth quality of service support, microversion `2.72` is required.

    Parameters:

      - name – Something to name the server.

      - image – The `Image` to boot with.

      - flavor – The `Flavor` to boot onto.

      - meta – A dict of arbitrary key/value metadata to store for this server. Both keys and values must be <=255 characters.

      - files – A dict of files to overwrite on the server upon boot. Keys are file names (i.e. `/etc/passwd`) and values are the file contents (either as a string or as a file-like object). A maximum of five entries is allowed, and each file must be 10k or less. (deprecated starting with microversion 2.57)

      - reservation_id – Return a reservation_id for the set of servers being requested, boolean.

      - min_count – The minimum number of servers to launch.

      - max_count – The maximum number of servers to launch.

      - security_groups – A list of security group names

      - userdata – User data to pass to be exposed by the metadata server this can be a file type object as well or a string.

      - key_name – Name of previously created keypair to inject into the instance.

      - availability_zone – Name of the availability zone for instance placement.

      - block_device_mapping – A dict of block device mappings for this server.

      - block_device_mapping_v2 – A list of block device mappings (dicts) for this server.

      - nics – An ordered list of nics (dicts) to be added to this server, with information about connected networks, fixed IPs, port etc. Beginning in microversion 2.37 this field is required and also supports a single string value of ‘auto’ or ‘none’. The ‘auto’ value means the Compute service will automatically allocate a network for the project if one is not available. This is the same behavior as not passing anything for nics before microversion 2.37. The ‘none’ value tells the Compute service to not allocate any networking for the server.

      - scheduler_hints – Arbitrary key-value pairs specified by the client to help boot an instance.

      - config_drive – A boolean value to enable config drive.

      - disk_config – Control how the disk is partitioned when the server is created. Possible values are ‘AUTO’ or ‘MANUAL’.

      - admin_pass – Add a user supplied admin password.

      - access_ip_v4 – Add alternative access IP (v4)

      - access_ip_v6 – Add alternative access IP (v6)

      - description – Optional description of the server (allowed since microversion 2.19)

      - tags – A list of arbitrary strings to be added to the server as tags (allowed since microversion 2.52)

      - trusted_image_certificates – A list of trusted certificate IDs (allowed since microversion 2.63)

      - host – Requested host to create servers (allowed since microversion 2.74)

      - hypervisor_hostname – Requested hypervisor hostname to create servers (allowed since microversion 2.74)

      - hostname – Requested hostname of server (allowed since microversion 2.90)

  create_image(server, image_name, metadata=None)

    Snapshot a server.

    Parameters:

      - server – The `Server` (or its ID) to share onto.

      - image_name – Name to give the snapshot image

      - metadata – Metadata to give newly-created image entity

    Returns:

      An instance of novaclient.base.StrWithMeta (The snapshot image’s UUID)

  delete(server)

    Delete (i.e. shut down and delete the image) this server.

    Parameters:

      server – The `Server` (or its ID) to delete

    Returns:

      An instance of novaclient.base.TupleWithMeta

  delete_all_tags(server)

    Remove all tags from an instance.

  delete_meta(server, keys)

    Delete metadata from a server

    Parameters:

      - server – The `Server` to add metadata to

      - keys – A list of metadata keys to delete from the server

    Returns:

      An instance of novaclient.base.TupleWithMeta

  delete_tag(server, tag)

    Remove single tag from an instance.

  diagnostics(server)

    Retrieve server diagnostics.

    Parameters:

      server – The `Server` (or its ID) for which diagnostics to be returned

    Returns:

      An instance of novaclient.base.TupleWithMeta

  evacuate(server, host=None, password=None)

    Evacuate a server instance.

    Parameters:

      - server – The `Server` (or its ID) to evacuate to.

      - host – Name of the target host.

      - password – string to set as password on the evacuated server.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  force_delete(server)

    Force delete the server.

    Parameters:

      server – The `Server` (or its ID) to force delete

    Returns:

      An instance of novaclient.base.TupleWithMeta

  get(server)

    Get a server.

    Parameters:

      server – ID of the `Server` to get.

    Return type:

      `Server`

  get_console_output(server, length=None)

    Get text console log output from Server.

    Parameters:

      - server – The `Server` (or its ID) whose console output you would like to retrieve.

      - length – The number of tail loglines you would like to retrieve.

    Returns:

      An instance of novaclient.base.StrWithMeta or novaclient.base.UnicodeWithMeta

  get_console_url(server, console_type)

    Retrieve a console url of a server.

    Parameters:

      - server – server to get console url for

      - console_type – type can be novnc/xvpvnc for protocol vnc; spice-html5 for protocol spice; rdp-html5 for protocol rdp; serial for protocol serial. webmks for protocol mks (since version 2.8).

  get_meta(server, key)

    Shows details for a metadata item, by key, for a server. :param server: The `Server` (or its ID). :param key: metadata key to get

  get_mks_console(server)

    Get a mks console for an instance

    Parameters:

      server – The `Server` (or its ID) to get console for.

    Returns:

      An instance of novaclient.base.DictWithMeta

  get_password(server, private_key=None)

    Get admin password of an instance

    Returns the admin password of an instance in the clear if private_key is provided, returns the ciphered password otherwise.

    Requires that openssl is installed and in the path

    Parameters:

      - server – The `Server` (or its ID) for which the admin password is to be returned

      - private_key – The private key to decrypt password (optional)

    Returns:

      An instance of novaclient.base.StrWithMeta or novaclient.base.BytesWithMeta or novaclient.base.UnicodeWithMeta

  get_rdp_console(server, console_type)

    Get a rdp console for an instance

    Parameters:

      - server – The `Server` (or its ID) to get console for.

      - console_type – Type of rdp console to get (‘rdp-html5’)

    Returns:

      An instance of novaclient.base.DictWithMeta

  get_serial_console(server, console_type)

    Get a serial console for an instance

    Parameters:

      - server – The `Server` (or its ID) to get console for.

      - console_type – Type of serial console to get (‘serial’)

    Returns:

      An instance of novaclient.base.DictWithMeta

  get_spice_console(server, console_type)

    Get a spice console for an instance

    Parameters:

      - server – The `Server` (or its ID) to get console for.

      - console_type – Type of spice console to get (‘spice-html5’)

    Returns:

      An instance of novaclient.base.DictWithMeta

  get_vnc_console(server, console_type)

    Get a vnc console for an instance

    Parameters:

      - server – The `Server` (or its ID) to get console for.

      - console_type – Type of vnc console to get (‘novnc’ or ‘xvpvnc’)

    Returns:

      An instance of novaclient.base.DictWithMeta

  interface_attach(server, port_id, net_id, fixed_ip, tag=None)

    Attach a network_interface to an instance.

    Parameters:

      - server – The `Server` (or its ID) to attach to.

      - port_id – The port to attach. The port_id and net_id parameters are mutually exclusive.

      - net_id – The ID of the network to attach.

      - fixed_ip – The fixed IP addresses. If the fixed_ip is specified, the net_id has to be specified at the same time.

      - tag – The tag.

  interface_detach(server, port_id)

    Detach a network_interface from an instance.

    Parameters:

      - server – The `Server` (or its ID) to detach from.

      - port_id – The port to detach.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  interface_list(server)

    List attached network interfaces

    Parameters:

      server – The `Server` (or its ID) to query.

  ips(server)

    Return IP Addresses associated with the server.

    Often a cheaper call then getting all the details for a server.

    Parameters:

      server – The `Server` (or its ID) for which the IP addresses are to be returned

    Returns:

      An instance of novaclient.base.DictWithMeta

  list(detailed=True, search_opts=None, marker=None, limit=None, sort_keys=None, sort_dirs=None)

    Get a list of servers.

    Parameters:

      - detailed – Whether to return detailed server info (optional).

      - search_opts – Search options to filter out servers which don’t match the search_opts (optional). The search opts format is a dictionary of key / value pairs that will be appended to the query string. For a complete list of keys see: https://docs.openstack.org/api-ref/compute/#list-servers

      - marker – Begin returning servers that appear later in the server list than that represented by this server id (optional).

      - limit – Maximum number of servers to return (optional). Note the API server has a configurable default limit. If no limit is specified here or limit is larger than default, the default limit will be used. If limit == -1, all servers will be returned.

      - sort_keys – List of sort keys

      - sort_dirs – List of sort directions

    Return type:

      list of `Server`

    Examples:

    client.servers.list() - returns detailed list of servers

    client.servers.list(search_opts={‘status’: ‘ERROR’}) - returns list of servers in error state.

    client.servers.list(limit=10) - returns only 10 servers

  list_meta(server)

    Lists all metadata for a server. :param server: The `Server` (or its ID). :returns: A dict of metadata.

  list_security_group(server)

    List Security Group(s) of an instance

    Parameters:

      server – ID of the instance.

  live_migrate(server, host, block_migration)

    Migrates a running instance to a new machine.

    Parameters:

      - server – instance id which comes from nova list.

      - host – destination host name.

      - block_migration – if True, do block_migration, can be set as ‘auto’

    Returns:

      An instance of novaclient.base.TupleWithMeta

  lock(server, reason=None)

    Lock the server.

    Parameters:

      - server – The `Server` (or its ID) to lock

      - reason – (Optional) The lock reason.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  migrate(server, host=None)

    Migrate a server to a new host.

    Parameters:

      - server – The `Server` (or its ID).

      - host – (Optional) The target host.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  pause(server)

    Pause the server.

    Parameters:

      server – The `Server` (or its ID) to pause

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reboot(server, reboot_type='SOFT')

    Reboot a server.

    Parameters:

      - server – The `Server` (or its ID) to share onto.

      - reboot_type – either `REBOOT_SOFT` for a software-level reboot, or REBOOT_HARD for a virtual power cycle hard reboot.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  rebuild(server, image, password=None, disk_config=None, preserve_ephemeral=False, name=None, meta=None, files=None, *, description=<object object>, key_name=<object object>, userdata=<object object>, trusted_image_certificates=<object object>, hostname=<object object>)

    Rebuild – shut down and then re-image – a server.

    Parameters:

      - server – The `Server` (or its ID) to share onto.

      - image – The `Image` (or its ID) to re-image with.

      - password – String to set as password on the rebuilt server.

      - disk_config – Partitioning mode to use on the rebuilt server. Valid values are ‘AUTO’ or ‘MANUAL’

      - preserve_ephemeral – If True, request that any ephemeral device be preserved when rebuilding the instance. Defaults to False.

      - name – Something to name the server.

      - meta – A dict of arbitrary key/value metadata to store for this server. Both keys and values must be <=255 characters.

      - files – A dict of files to overwrite on the server upon boot. Keys are file names (i.e. `/etc/passwd`) and values are the file contents (either as a string or as a file-like object). A maximum of five entries is allowed, and each file must be 10k or less. (deprecated starting with microversion 2.57)

      - description – Optional description of the server. If None is specified, the existing description will be unset. (starting from microversion 2.19)

      - key_name – Optional key pair name for rebuild operation. If None is specified, the existing key will be unset. (starting from microversion 2.54)

      - userdata – Optional user data to pass to be exposed by the metadata server; this can be a file type object as well or a string. If None is specified, the existing user_data is unset. (starting from microversion 2.57)

      - trusted_image_certificates – A list of trusted certificate IDs or None to unset/reset the servers trusted image certificates (starting from microversion 2.63)

      - hostname – Optional hostname to configure for the instance. If None is specified, the existing hostname will be unset. (starting from microversion 2.90)

    Returns:

      `Server`

  remove_security_group(server, security_group)

    Remove a Security Group to an instance

    Parameters:

      - server – ID of the instance.

      - security_group – The name of security group to remove.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  rescue(server, password=None, image=None)

    Rescue the server.

    Parameters:

      - server – The `Server` to rescue.

      - password – The admin password to be set in the rescue instance.

      - image – The `Image` to rescue with.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reset_network(server)

    Reset network of an instance.

    Parameters:

      server – The `Server` for network is to be reset

    Returns:

      An instance of novaclient.base.TupleWithMeta

  reset_state(server, state='error')

    Reset the state of an instance to active or error.

    Parameters:

      - server – ID of the instance to reset the state of.

      - state – Desired state; either ‘active’ or ‘error’. Defaults to ‘error’.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  resize(server, flavor, disk_config=None)

    Resize a server’s resources.

    Parameters:

      - server – The `Server` (or its ID) to share onto.

      - flavor – The `Flavor` (or its ID) to resize to.

      - disk_config – Partitioning mode to use on the rebuilt server. Valid values are ‘AUTO’ or ‘MANUAL’.

    Returns:

      An instance of novaclient.base.TupleWithMeta

    Until a resize event is confirmed with `confirm_resize()`, the old server will be kept around and you’ll be able to roll back to the old flavor quickly with `revert_resize()`. All resizes are automatically confirmed after 24 hours by default.

  resource_class

    alias of `Server`

  restore(server)

    Restore soft-deleted server.

    Parameters:

      server – The `Server` (or its ID) to restore

    Returns:

      An instance of novaclient.base.TupleWithMeta

  resume(server)

    Resume the server.

    Parameters:

      server – The `Server` (or its ID) to resume

    Returns:

      An instance of novaclient.base.TupleWithMeta

  revert_resize(server)

    Revert a previous resize, switching back to the old server.

    Parameters:

      server – The `Server` (or its ID) to share onto.

    Returns:

      An instance of novaclient.base.TupleWithMeta

  set_meta(server, metadata)

    Set a server’s metadata :param server: The `Server` to add metadata to :param metadata: A dict of metadata to be added to the server

  set_meta_item(server, key, value)

    Updates an item of server metadata :param server: The `Server` to add metadata to :param key: metadata key to update :param value: string value

  set_tags(server, tags)

    Set list of tags to an instance.

  shelve(server)

    Shelve the server.

    Parameters:

      server – The `Server` (or its ID) to shelve

    Returns:

      An instance of novaclient.base.TupleWithMeta

  shelve_offload(server)

    Remove a shelved instance from the compute node.

    Parameters:

      server – The `Server` (or its ID) to shelve offload

    Returns:

      An instance of novaclient.base.TupleWithMeta

  start(server)

    Start the server.

    Parameters:

      server – The `Server` (or its ID) to start

    Returns:

      An instance of novaclient.base.TupleWithMeta

  stop(server)

    Stop the server.

    Parameters:

      server – The `Server` (or its ID) to stop

    Returns:

      An instance of novaclient.base.TupleWithMeta

  suspend(server)

    Suspend the server.

    Parameters:

      server – The `Server` (or its ID) to suspend

    Returns:

      An instance of novaclient.base.TupleWithMeta

  tag_list(server)

    Get list of tags from an instance.

  topology(server)

    Retrieve server topology.

    Parameters:

      server – The `Server` (or its ID) for which topology to be returned

    Returns:

      An instance of novaclient.base.DictWithMeta

  static transform_userdata(userdata)
  trigger_crash_dump(server)

    Trigger crash dump in an instance

  unlock(server)

    Unlock the server.

    Parameters:

      server – The `Server` (or its ID) to unlock

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unpause(server)

    Unpause the server.

    Parameters:

      server – The `Server` (or its ID) to unpause

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unrescue(server)

    Unrescue the server.

    Parameters:

      server – The `Server` (or its ID) to unrescue

    Returns:

      An instance of novaclient.base.TupleWithMeta

  unshelve(server, availability_zone=<object object>, host=None)

    Unshelve the server.

    Parameters:

      - availability_zone – If specified the instance will be unshelved to the availability_zone. If None is passed the instance defined availability_zone is unpin and the instance will be scheduled to any availability_zone (free scheduling). If not specified the instance will be unshelved to either its defined availability_zone or any availability_zone (free scheduling).

      - host – The specified host (Optional)

    Returns:

      An instance of novaclient.base.TupleWithMeta

  update(server, name=None, description=None, hostname=None)

    Update attributes of a server.

    Parameters:

      - server – The `Server` (or its ID) to update.

      - name – Update the server’s name.

      - description – Update the server’s description. If it equals to empty string(i.g. “”), the server description will be removed.

      - hostname – Update the server’s hostname as recorded by the metadata service. Note that a separate utility running on the guest will be necessary to reflect these changes in the guest itself.

    Returns:

      `Server`

this page last updated: 2026-07-15 14:18:20

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug